package repository

import (
	"Zadanie3VaytsuApi/main/models"
	"context"
	"fmt"
	"log"
)

func (repo *PGrepo) GetEquipment(offset int, limit int) ([]models.Equipment, error) {
	rows, err := repo.pool.Query(context.Background(), "select * from Equipment LIMIT $1 OFFSET $2", limit, offset)
	if err != nil {
		log.Fatal(err)
		return nil, err
	}
	defer rows.Close()
	var equipments []models.Equipment
	for rows.Next() {
		equipment := models.Equipment{}
		err := rows.Scan(&equipment.GUID, &equipment.InventoryNumber, &equipment.Name, &equipment.OwnerId, &equipment.ReceiptDate,
			&equipment.LifeTime)

		if err != nil {
			fmt.Println(err)
			continue
		}

		equipments = append(equipments, equipment)
	}
	return equipments, nil
}
func (repo *PGrepo) GetEquipmentWithInventoryNumber(offset int, limit int, number int) ([]models.Equipment, error) {
	rows, err := repo.pool.Query(context.Background(), "select * from Equipment WHERE inventoryNumber = $3 LIMIT $1 OFFSET $2", limit, offset, number)
	if err != nil {
		log.Fatal(err)
		return nil, err
	}
	defer rows.Close()
	var equipments []models.Equipment
	for rows.Next() {
		equipment := models.Equipment{}
		err := rows.Scan(&equipment.GUID, &equipment.InventoryNumber, &equipment.Name, &equipment.OwnerId, &equipment.ReceiptDate,
			&equipment.LifeTime)

		if err != nil {
			fmt.Println(err)
			continue
		}

		equipments = append(equipments, equipment)
	}
	return equipments, nil
}
func (repo *PGrepo) GetEquipmentWithOwnerId(offset int, limit int, ownerid int) ([]models.Equipment, error) {
	rows, err := repo.pool.Query(context.Background(), "select * from Equipment WHERE OwnerId = $3 LIMIT $1 OFFSET $2", limit, offset, ownerid)
	if err != nil {
		log.Fatal(err)
		return nil, err
	}
	defer rows.Close()
	var equipments []models.Equipment
	for rows.Next() {
		equipment := models.Equipment{}
		err := rows.Scan(&equipment.GUID, &equipment.InventoryNumber, &equipment.Name, &equipment.OwnerId, &equipment.ReceiptDate,
			&equipment.LifeTime)

		if err != nil {
			fmt.Println(err)
			continue
		}

		equipments = append(equipments, equipment)
	}
	return equipments, nil
}
